﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Text;
using System.Threading;

namespace perf2
{
    class Program
    {
        private const int MAX = 1000000;
        private static Random rnd = new Random();
        private static ICollection<int> tableau;

        public static void creerTab(int taille, string type)
        {

            switch (type)
            {
                case "List":
                    tableau = new List<int>();
                    break;
                case "LinkedList":
                    tableau = new LinkedList<int>();
                    break;
                case "hash":
                    tableau = new HashSet<int>();
                    break;
                default:
                    tableau = new List<int>();
                    break;
            }

            for(int i = 0; i < taille; i++)
            {
                int nb = rnd.Next(MAX);
                tableau.Add(nb);
            }
        }

        public static void ajout(int taille)
        {
              int nb = rnd.Next(MAX);
              tableau.Add(nb);
        }

        public static bool acces()
        {
            int nbRech = rnd.Next(MAX);
            return tableau.Contains(nbRech);
        }

        public static int max()
        {
            return tableau.Max();
        }

        /*
         * Args : 0 -> structure (List / LinkedList)
         *        1 -> operation (Remplissage / acces / max)
         *        2 -> taille
         *        3 -> nombre d'operations
         */
        static void Main(string[] args)
        {
            Program.creerTab(Convert.ToInt32(args[2]), args[0]);

            if (args[1] == "ajout"){
              for(int i=0; i < Convert.ToInt32(args[3]); i++)
                Program.ajout(Convert.ToInt32(args[2]));
            }
            else if (args[1] == "acces")
            {
              for(int i=0; i < Convert.ToInt32(args[3]); i++)
                Program.acces();
            }
            else if (args[1] == "max"){
              for(int i=0; i < Convert.ToInt32(args[3]); i++)
                  Program.max();
            }
        }
    }
}
