# P4a : Analyse de performances de différentes structures

[Grille d'évaluation P4a](https://docs.google.com/spreadsheets/d/1x72glVEQHPx56Wr8G0RNQgfQXGX6xCsjms_6b7J6si0/edit?usp=sharing
)

## Problème

Nous avons décidés de nous intéresser aux différences de performance des types "List", "LinkedList" pour 2 opérations qui sont :
    L'ajout,
    La recherche,

Les paramètres exploratoires de cette expérience sont :
    Nombre d'élements :
    Nombre d'opérations :
    
Nous évalurons le temps d'exécution et la taille mémoire

## Dispositif expérimental

### Application

[code source de l'application](chemin)
```
Description de l'application et des arguments

mono Program.cs <type de structure> <opération> <taille> <nombre d'opérations>
```

Type de structures :

-List
-LinkedList

opération :

-Remplissage
-acces

### Environnement de test

Description de la plateforme de test
```
Les tests furent réalisés sur le serveur à distance TROGLO de l'IUT
```

### Description de la démarche systématique

On utilise un script shell afin de lancer plusieurs fois les opérations voulus et de les enregistrer dans un fichier perf.dat.

Le programme lance 10 000 les fonction Contains et Acces à l'intérieur d'une List ou une LinkedList contenant des valeurs random d'une taille allant de 10 a 1 000 000 de valeurs

```
Suite des commandes, ou script, à exécuter pour produire les données.
/usr/bin/time -f %M de mono Program.cs [arg0] [arg1] [arg2] [arg3].
```

## Résultats préalables

### Temps d'exécution

| Opération            | Tableau                   | Liste chaînée             |                           |
|----------------------|---------------------------|---------------------------|---------------------------|
| Insertion            | ![plot](path/to/plot.png) | ![plot](path/to/plot.png) | ![plot](path/to/plot.png) |
| Accès                | ![plot](path/to/plot.png) | ![plot](path/to/plot.png) | ![plot](path/to/plot.png) |
|                      | ![plot](path/to/plot.png) | ![plot](path/to/plot.png) | ![plot](path/to/plot.png) |

### Consommation mémoire

| Opération            | Tableau                   | Liste chaînée             |                           |
|----------------------|---------------------------|---------------------------|---------------------------|
| Insertion            | ![plot](path/to/plot.png) | ![plot](path/to/plot.png) | ![plot](path/to/plot.png) |
| Accès                | ![plot](path/to/plot.png) | ![plot](path/to/plot.png) | ![plot](path/to/plot.png) |
|                      | ![plot](path/to/plot.png) | ![plot](path/to/plot.png) | ![plot](path/to/plot.png) |

### Analyse des résultats préalables

Nos resultats n'ont pu être observé qu'a un format texte suite a notre incapacité a réaliser les graphiques demandés.
Nos resultats ne sont pas très significatifs mais on peut observé que l'insertion est plus couteuse sur les linkedList que sur les List.

### Discussion des résultats préalables

Explications précises et succinctes sur ce que les limites des résultats
préalables et ce qu'ils ne permettent pas de vérifier.

## Etude approfondie

### Hypothèse

Expression précise et succincte d'une hypothèse.

### Protocole expérimental de vérification de l'hypothèse

Expression précise et succincte du protocole.

```
Suite des commandes, ou script, à exécuter pour produire les données.
```

### Résultats expérimentaux

### Analyse des résultats expérimentaux

### Discussion des résultats expérimentaux

## Conclusion et travaux futurs
